List Tools

List Tools
List tools available from configured servers.

This method allows you to list tools available from configured MCP servers.

Request
URI
GET
https://{api_host}/api/v1/control/mcp-servers/tools
COPY
Query Parameters
string
after
Optional

Optional object ID after which to resume pagination.

string
before
Optional

Optional object ID after which to resume pagination.

integer
limit
Optional
Constraints: exclusiveMinimum: 0 exclusiveMaximum: 1000 default: 100

Number of objects to return in the request.

integer
offset
Optional
Constraints: minimum: 0 maximum: 4294967296 default: 0

Skip this many objects in the returned list. This can be used for pagination (instead of, or in addition to, using after/before), but it is less robust to list changes occurring during pagination.

string
order
Optional
Constraints: default: asc

Order (based on create time) for returned objects.

Possible values are : asc, desc,
boolean
set_num_objects
Optional
Constraints: default: false

If set, calculate the total number of objects that match the request, and include the value as num_objects in the response. Calculating the size of large listings may be costly and is disabled by default.

string of array
tool_ids
Optional

A list of tool IDs to filter by. Returns only tools matching any of the specified IDs.

array
server
Optional

A list of MCP servers for which to list tools. For tools from external MCP servers, the item to filter on is the MCP Server ID; for tools from the built-in MCP server, use "built-in".

boolean
is_approved
Optional

Filter tools by approval status. If not set, both approved and unapproved tools are returned.

availability
Optional

Filter tools by availability status.

order_by
Optional

The fields to sort the tools by, specified in order of precedence.


Authentication
This operation uses the following authentication methods.
Responses
200

Successful Response

Returns ToolListResponse of type(s) application/json
{
    "object": "string",
    "has_more": false,
    "num_objects": 0,
    "data": [
        {
            "id": "string",
            "server": {
                "id": "string",
                "name": "string"
            },
            "tool_type": "string",
            "tool_configuration_type": "string",
            "origin_name": "string",
            "description": "string",
            "annotations": "string",
            "input_schema": "string",
            "output_schema": "string",
            "is_approved": false,
            "availability": "string",
            "last_available_at": 0,
            "last_updated_at": 0,
            "num_linked_agents": 0
        }
    ],
    "first_id": "string",
    "last_id": "string"
}
string
object
Optional
Constraints: default: list

Object type, which is always list.

boolean
has_more
Optional

True, if the server may have more objects than returned in the response.

integer
num_objects
Required

Total number of objects that match the request. Note that this field is populated only if requested by the user (see set_num_objects request parameter).

array of object
data
Required

List of Tools.

string As uuid As uuid
first_id
Required

ID of the first element in the list (if any)

string As uuid As uuid
last_id
Required

ID of the last element in the list (if any)


410

An invalid ID was passed for paginating results.

Operation doesn't return any data structure

422

Validation Error

Returns HTTPValidationError of type(s) application/json
{
    "detail": [
        {
            "loc": [
                {}
            ],
            "msg": "string",
            "type": "string"
        }
    ]
}
array of object
detail
Optional

detail


Code Samples
COPY
                    curl -H 'Authorization: <value>' https://{api_host}/api/v1/control/mcp-servers/tools